unit formclient;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	ExtCtrls, Buttons, StdCtrls, SPLocker, ActnList, ImgList, ComCtrls;

type
  TClientForm = class(TForm)
    SPLocker: TSPLocker;
    lbLocks: TListBox;
    cbMutex: TComboBox;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    ActionList: TActionList;
    ImageList: TImageList;
    actAqcuire: TAction;
    actRelease: TAction;
    actQuit: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    cbMessage: TCheckBox;
    StatusBar1: TStatusBar;
    procedure actReleaseExecute(Sender: TObject);
		procedure actAqcuireExecute(Sender: TObject);
    procedure actQuitExecute(Sender: TObject);
    procedure actAqcuireUpdate(Sender: TObject);
		procedure actReleaseUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
	private
		procedure updateMutexCaption;
		{ Private declarations }
	public
		{ Public declarations }
	end;

var
	ClientForm: TClientForm;

implementation

uses
	FormMain;

{$R *.DFM}

procedure TClientForm.updateMutexCaption;
begin
	StatusBar1.SimpleText := Format('Acquired Locks (%d):',[lbLocks.Items.Count]);
end;

procedure TClientForm.actReleaseExecute(Sender: TObject);
var
	n: Integer;
	s: String;
begin
	n := lbLocks.ItemIndex;
	s := lbLocks.Items[n];
	lbLocks.Items.Objects[n].Free;
	lbLocks.Items.Delete(n);
	updateMutexCaption;
	// try to select another lock with the same name ...
	lbLocks.ItemIndex := lbLocks.Items.IndexOf(s); 
end;

procedure TClientForm.actAqcuireExecute(Sender: TObject);
var
	L: TSPLock;
begin
	L := SPLocker.Acquire(cbMutex.Text);
	if L <> nil then
	begin
		lbLocks.Items.AddObject(cbMutex.Text,L);
		updateMutexCaption;
	end
	else
		if cbMessage.Checked then
			ShowMessage(Format('Failed to lock %s (because it is in use).',[cbMutex.Text]));
end;

procedure TClientForm.actQuitExecute(Sender: TObject);
begin
	Close;
end;

procedure TClientForm.actAqcuireUpdate(Sender: TObject);
begin
	TAction(Sender).Enabled :=
		(Length(cbMutex.Text) > 0)
//	Uncomment this to check for valid key before trying the lock
//		and SPLocker.ValidKey(cbMutex.Text);
//
	;
end;

procedure TClientForm.actReleaseUpdate(Sender: TObject);
begin
	TAction(Sender).Enabled := lbLocks.ItemIndex > -1;
end;

procedure TClientForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	MainForm.delClient(MainForm.lbClients.Items.IndexOfObject(Self));
	Action := caFree;
end;

procedure TClientForm.FormCreate(Sender: TObject);
begin
	Caption := Name;
	cbMutex.ItemIndex := 0;
end;

end.
